$mod51
;***********************************************************************
;    pwr.asm pay and draw power program by V D NAYAK
;***********************************************************************
;   p3.0		coin detect pulse
;   p3.1		power on switch
;   p3.2		monostable pulse(time duration)sensed  via transistor
;   
;   p3.7		coin sensed LED
;   
;  
;   p1.0		monostable triggering signal
;   p1.1		relay on or POWER BEING CONSUMED LED indicator
;   
;    p1.4 to p1.7  input to CD 4511 ( 6.1,2,7)to dsplay on 7seg
;   r0,r1 	for delay
;   r2		count for 7 seg display
;   r3		count of 5 monostable pulses (ASSUME Rs 1/1 MIN approx)
;  ( r4 		flag ON already triggered
;   r5		flag  timer already triggered ) not used,for further development
;   r6                 count upto 5 
;   r7                  count for 7 seg display left justified
;***********************************************************************

		org 000h
		sjmp start
		org 040h
start:
		;-------------------- INITIALISATION START--------------------------------
                        mov r3,#000h			;count is 0
		mov r4,#000h			;flag reset
		mov r5,#000h			;mono on flag reset
		mov r2,#000h			;coin count 0
		mov r6,#005h			;counter set to 5
		mov r7,#000h
		setb p3.0			;no coin detected
		setb p3.2			;mono output detected set high
		clr   p3.7			;coin detected LED off
		clr   p1.1			; relay de-energised
		setb p1.0			; monostable not triggered
		clr   p1.4			;
		clr   p1.5			;  7 seg display 0
		clr   p1.6			;
		clr   p1.7			;		
		;---------------------INITIALISATION OVER-----------------------------------

		acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
tstcount:
		mov a,r3
		cjne a,#000h,tstpwrsw
		clr p1.1			;if r3=0 denergise relay
		;-----------------------------------------------------------------
coindet:
		jnb p3.0,updtr3		;coin sensed
		mov r4,#000h			;flag reset
		;------------------PUTTING COUNT ON 7 SEG  START----------------------
		mov a,r2			;no of coins detected
   		rl a			;
		rl a			;
		rl a			; no of coins count in MS of  r2
		rl a			;
		mov b,a		; copy in b
		mov a,p1
		anl    a,#00fh		;extract LS portin keep intact
		orl     a,b		;count ored in a
		mov   p1,a
		;-------------------PUTTING COUNT ON 7SEG     OVER---------------

		sjmp tstcount
updtr3:
		mov a,r3
		add a,#005h
		clr   c
		mov r3,a		;5 added in r3
		mov a,r2		; count no of coins in r2
		inc a
		clr c
		cjne a,#10, max
		mov a,#9
	max:    mov r2,a
		acall coin		; EVERY TIME COIN SENSED
		sjmp tstcount
		;-----------------------------------------------

tstpwrsw:
		jnb p3.1,swpwron
		clr  p1.1
		sjmp  coindet
swpwron:
		setb p1.1		;relay on
		jnb p3.2,coindet	; is delay running ? if yes go and sense coin
		dec r3
		dec r6			; reduce count from 5 set in r6
		mov a,r6
		cjne a,#000h,bypssr2
		dec r2			; 1 subtracted  from r2 for every 5 in r3
	 	mov a,r2
		jz min
		rl a
		rl a
		rl a
		rl a
		clr  c
		mov b,a
		mov a,p1
		anl a,#00fh
		orl a,b
		mov p1,a
		mov r6,#005h		;initial count of 5 in r6
		;--------------------------------------------------------------------
bypssr2:
	            acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
                        acall delay
trigr:
		clr  p1.0		;
		acall delay		;   mono triggered
	
		setb p1.0		;
	   
	
		 ajmp tstcount                        
           min:	mov p1,#01h   
		ajmp tstcount      
;---------------------------------------ROUTINES----------------------------------
delay:
		mov r0,#0c8h
loop2:
		mov r1,#0fah
loop1:
		nop
		nop
		nop
djnz r1,loop1		;loop1 approx 5 X 200=1msec
djnz r0,loop2		;loop2 250 X 1msec    =250 msec
ret

coin:
       setb  p3.7
       acall delay
       acall delay
       acall delay
       acall delay
       clr   p3.7
       acall delay
       acall delay
       acall delay
       acall delay
       ret
;---------------------------------------------------
 end




	



